#include "stdafx.h"
#include "Gravity.h"

#define MAX_LOADSTRING 100

//  :
HINSTANCE hInst;								//  
TCHAR szTitle[MAX_LOADSTRING];					//   
TCHAR szWindowClass[MAX_LOADSTRING];			//    
BOOL think = true;
PlanetSystem Pl(100); 

//   ,     :
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
                     _In_opt_ HINSTANCE hPrevInstance,
                     _In_ LPTSTR    lpCmdLine,
                     _In_ int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO:   .
	MSG msg;
	HACCEL hAccelTable;

	//   
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_GRAVITY, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	//   :
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_GRAVITY));

	//   :
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  : MyRegisterClass()
//
//  :   .
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_GRAVITY));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_GRAVITY);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   : InitInstance(HINSTANCE, int)
//
//   :       .
//
//   :
//
//                ,  
//               .
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; //      

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

DWORD WINAPI  thinking(LPVOID lpParameter)
{
	while(think)
	{
		Pl.Step(1);
	}
	return 0;
}

//
//  : WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  :      .
//
//  WM_COMMAND	-   
//  WM_PAINT	-  
//  WM_DESTROY	 -      .
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	RECT R;
	const double Sc = 0.5E9;
	static HANDLE hThread;

	switch (message)
	{
	case WM_CREATE:
		Pl.AddPlanet(0.98892E30,    -1E10,0,  0,2E4,     RGB(255,128,0));
		Pl.AddPlanet(0.98892E30,    +1E10,0,  0,-2E4,     RGB(255,128,0));
		Pl.AddPlanet(5.9726E24,   1.49E11,0,  0,30E3, RGB(0,127,255));
		Pl.AddPlanet(0.64185E29,  2.28E11,0,  0,10E3, RGB(255,0,0));
		SetTimer(hWnd,1,100,NULL);
		hThread=CreateThread(NULL,0,thinking,0,0,NULL);
		break;
	case WM_TIMER:
		InvalidateRect(hWnd,NULL,false);
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		//    :
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		
		GetClientRect(hWnd,&R);
		
		SetMapMode(hdc,MM_ISOTROPIC);
		SetViewportExtEx(hdc,1,1,NULL);	
		SetWindowExtEx(hdc,1,-1,NULL);
		
		SetViewportOrgEx(hdc,R.right/2,R.bottom/2,NULL);
		
		Pl.Paint(hdc,Sc);

		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		think=false;
		WaitForSingleObject(hThread,1000);
		KillTimer(hWnd,1);
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

//     " ".
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
