#include "stdafx.h"

inline double sqr(double x) { return x*x; }

PlanetSystem::PlanetSystem(int N)
{
	p = new Pplanet[NUM=N];
	Num=0;
}

bool PlanetSystem::AddPlanet(double M, double X, double Y, double U, double V, int C)
{
	if (Num<NUM)
	{
		p[Num++]=new Planet(M,X,Y,U,V,C);
		return true;
	}
	else return false;
}

void PlanetSystem::Step(double Dt)
{
	double Ax, Ay, a;
	double r, r2;

	for (int i=0; i<Num; i++) //   
	{   Ax=0; Ay=0;
	    for (int j=0; j<Num; j++) if (i!=j)
		{
		  r2=sqr(p[i]->x-p[j]->x)+sqr(p[i]->y-p[j]->y);
		  a=-G*(p[j]->m)/r2; r=sqrt(r2);
		  Ax+=a*(p[i]->x-p[j]->x)/r;
		  Ay+=a*(p[i]->y-p[j]->y)/r;
		}
		p[i]->Accel(Ax,Ay);
	}

	for (int i=0; i<Num; i++) p[i]->Step(Dt);


}

void PlanetSystem::Paint(HDC hdc,double Sc)
{
	for (int i=0; i<Num; i++) p[i]->Paint(hdc,Sc);
}

// ============== Planet =================

Planet::Planet(double M, double X, double Y, double U, double V, int C)
{
	m=M;
	x=X; y=Y;
	u=U; v=V;
	c=C;
	ax=0; ay=0;
}

void Planet::Accel(double Ax, double Ay)
{
	ax=Ax; ay=Ay;
}

void Planet::Step(double Dt)
{
	double U = u, V = v;
	u+=ax*Dt; v+=ay*Dt;
	x+=0.5*(U+u)*Dt; y+=0.5*(V+v)*Dt;
}

void Planet::Paint(HDC hdc,double Sc)
{   const int r=2;
	int i, j;
	HPEN Pen, OldPen;
	
	i=x/Sc; j= y/Sc;
	
	SetPixel(hdc,i,j,c);

	/*
	Pen=CreatePen(PS_SOLID,1,c);
	OldPen=(HPEN) SelectObject(hdc,Pen);
	
	Ellipse(hdc,i-r,j-r,i+r,j+r);
	
	SelectObject(hdc,OldPen);
	DeleteObject(Pen);
	*/
}
